## tcmu 1.4.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8 FATAL_ERROR)
project (tcmu-runner C)
set(VERSION 1.4.0)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wall -Wdeclaration-after-statement -std=c99")

include(GNUInstallDirs)
include(CheckIncludeFile)

set(tcmu-runner_HANDLER_PATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/tcmu-runner")

option(with-glfs "build Gluster glfs handler" true)
option(with-qcow "build qcow handler" true)
option(with-rbd "build Ceph rbd handler" true)

find_library(LIBNL_LIB nl-3)
find_library(LIBNL_GENL_LIB nl-genl-3)
set(LIBNL_LIBS
  ${LIBNL_LIB}
  ${LIBNL_GENL_LIB}
  )

find_path (LIBNL_INCLUDE_DIR
  NAMES
  netlink/netlink.h
  PATH_SUFFIXES
  libnl3
  )

find_package(PkgConfig)
pkg_check_modules(GLIB REQUIRED gio-unix-2.0)
pkg_check_modules(KMOD REQUIRED libkmod)

find_library(PTHREAD pthread)
find_library(DL dl)

# Stuff for building the shared library
add_library(tcmu
  SHARED
  strlcpy.c
  configfs.c
  api.c
  libtcmu.c
  libtcmu-register.c
  tcmuhandler-generated.c
  libtcmu_log.c
  libtcmu_config.c
  libtcmu_time.c
  )
set_target_properties(tcmu
  PROPERTIES
  SOVERSION "2"
  )
target_include_directories(tcmu
  PUBLIC ${LIBNL_INCLUDE_DIR}
  PUBLIC ${GLIB_INCLUDE_DIRS}
  PUBLIC ${PROJECT_SOURCE_DIR}/ccan
  )
target_link_libraries(tcmu
  ${LIBNL_LIB}
  ${LIBNL_GENL_LIB}
  ${GLIB_LIBRARIES}
  )
install(TARGETS tcmu LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} NAMELINK_SKIP)

# Stuff for building the static library
add_library(tcmu_static
  strlcpy.c
  configfs.c
  api.c
  libtcmu.c
  libtcmu-register.c
  tcmuhandler-generated.c
  libtcmu_log.c
  libtcmu_config.c
  libtcmu_time.c
  )
target_include_directories(tcmu_static
  PUBLIC ${LIBNL_INCLUDE_DIR}
  PUBLIC ${GLIB_INCLUDE_DIRS}
  PUBLIC ${PROJECT_SOURCE_DIR}/ccan
  )
target_link_libraries(tcmu_static
  ${GLIB_LIBRARIES}
  )

# Stuff for building the main binary
add_executable(tcmu-runner
  tcmur_cmd_handler.c
  tcmur_aio.c
  tcmur_device.c
  target.c
  alua.c
  main.c
  tcmuhandler-generated.c
  )
target_link_libraries(tcmu-runner tcmu)
target_include_directories(tcmu-runner
  PUBLIC ${PROJECT_BINARY_DIR}
  PUBLIC ${GLIB_INCLUDE_DIRS}
  PUBLIC ${KMOD_INCLUDE_DIRS}
  PUBLIC ${PROJECT_SOURCE_DIR}/ccan
  )
target_link_libraries(tcmu-runner
  ${GLIB_LIBRARIES}
  ${PTHREAD}
  ${DL}
  ${KMOD_LIBRARIES}
  -Wl,--no-export-dynamic
  -Wl,--dynamic-list=${CMAKE_SOURCE_DIR}/main-syms.txt
  )
install(TARGETS tcmu-runner RUNTIME DESTINATION bin)

add_executable(tcmu-synthesizer
  tcmu-synthesizer.c
  )
target_link_libraries(tcmu-synthesizer tcmu)
target_include_directories(tcmu-synthesizer
  PUBLIC ${PROJECT_BINARY_DIR}
  PUBLIC ${GLIB_INCLUDE_DIRS}
  PUBLIC ${PROJECT_SOURCE_DIR}/ccan
  )
target_link_libraries(tcmu-synthesizer
  ${GLIB_LIBRARIES}
  )

install(TARGETS RUNTIME DESTINATION bin)

add_custom_command(
  OUTPUT ${CMAKE_SOURCE_DIR}/tcmuhandler-generated.c ${CMAKE_SOURCE_DIR}/tcmuhandler-generated.h
  COMMAND gdbus-codegen ${CMAKE_SOURCE_DIR}/tcmu-handler.xml --generate-c-code ${CMAKE_SOURCE_DIR}/tcmuhandler-generated --c-generate-object-manager --interface-prefix org.kernel
  MAIN_DEPENDENCY tcmu-handler.xml
  )

add_custom_target(
  cscope
  COMMAND find -name '*.[ch]' > cscope.files
  COMMAND cscope -bq
  )
set_directory_properties(
  PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
  "cscope.files;cscope.in.out;cscope.out;cscope.po.out"
  )

# Stuff for building the file handler
add_library(handler_file
  SHARED
  file_example.c
  )
set_target_properties(handler_file
  PROPERTIES
  PREFIX ""
  )
target_include_directories(handler_file
  PUBLIC ${PROJECT_SOURCE_DIR}/ccan
  )

# Stuff for building the file optical handler
add_library(handler_file_optical
  SHARED
  file_optical.c
  )
set_target_properties(handler_file_optical
  PROPERTIES
  PREFIX ""
  )
target_include_directories(handler_file_optical
  PUBLIC ${PROJECT_SOURCE_DIR}/ccan
  )
target_link_libraries(handler_file_optical ${PTHREAD})

# Stuff for building the file zbc handler
add_library(handler_file_zbc
  SHARED
  file_zbc.c
  )
set_target_properties(handler_file_zbc
  PROPERTIES
  PREFIX ""
  )
target_include_directories(handler_file_zbc
  PUBLIC ${PROJECT_SOURCE_DIR}/ccan
  )
install(TARGETS handler_file_zbc DESTINATION ${CMAKE_INSTALL_LIBDIR}/tcmu-runner)

# The minimal library consumer
add_executable(consumer
  consumer.c
  )
target_link_libraries(consumer tcmu)

if (with-rbd)
	find_library(LIBRBD rbd)

	# Stuff for building the rbd handler
	add_library(handler_rbd
	  SHARED
	  rbd.c
	  )
	set_target_properties(handler_rbd
	  PROPERTIES
	  PREFIX ""
	  )
	target_include_directories(handler_rbd
	  PUBLIC ${PROJECT_SOURCE_DIR}/ccan
	  )
	target_link_libraries(handler_rbd
	  ${LIBRBD}
	  )
	install(TARGETS handler_rbd DESTINATION ${CMAKE_INSTALL_LIBDIR}/tcmu-runner)
endif (with-rbd)

if (with-glfs)
	find_library(GFAPI gfapi)

	# Stuff for building the glfs handler
	add_library(handler_glfs
	  SHARED
	  glfs.c
	  )
	set_target_properties(handler_glfs
	  PROPERTIES
	  PREFIX ""
	  )
	target_include_directories(handler_glfs
	  PUBLIC ${PROJECT_SOURCE_DIR}/ccan
	  )
	target_link_libraries(handler_glfs
	  ${GFAPI}
	  )
	install(TARGETS handler_glfs DESTINATION ${CMAKE_INSTALL_LIBDIR}/tcmu-runner)
endif (with-glfs)

if (with-qcow)
	find_package(ZLIB REQUIRED)

	# Stuff for building the qcow handler
	add_library(handler_qcow
	  SHARED
	  qcow.c
	  )
	set_target_properties(handler_qcow
	  PROPERTIES
	  PREFIX ""
	  )
	target_include_directories(handler_qcow
	  PUBLIC ${PROJECT_SOURCE_DIR}/ccan
	  )

	CHECK_INCLUDE_FILE("linux/falloc.h" HAVE_LINUX_FALLOC)
	if (HAVE_LINUX_FALLOC)
		set_target_properties(handler_qcow
		  PROPERTIES
		  COMPILE_FLAGS "-DHAVE_LINUX_FALLOC"
		  )
	endif (HAVE_LINUX_FALLOC)
	target_link_libraries(handler_qcow
	  ${ZLIB_LIBRARIES}
	  )
	install(TARGETS handler_qcow DESTINATION ${CMAKE_INSTALL_LIBDIR}/tcmu-runner)
endif (with-qcow)

# stamp out a header file to pass some of the CMake settings
# to the source code
configure_file (
  "${PROJECT_SOURCE_DIR}/version.h.in"
  "${PROJECT_SOURCE_DIR}/version.h"
  )

configure_file (
  "${PROJECT_SOURCE_DIR}/tcmu.conf_install.cmake.in"
  "${PROJECT_SOURCE_DIR}/tcmu.conf_install.cmake"
  )
install(SCRIPT tcmu.conf_install.cmake)

configure_file (
  "${PROJECT_SOURCE_DIR}/logrotate.conf_install.cmake.in"
  "${PROJECT_SOURCE_DIR}/logrotate.conf_install.cmake"
  )
install(SCRIPT logrotate.conf_install.cmake)

install(FILES org.kernel.TCMUService1.service
  DESTINATION /usr/share/dbus-1/system-services)
install(FILES tcmu-runner.conf DESTINATION /etc/dbus-1/system.d)
if (SUPPORT_SYSTEMD)
  install(FILES tcmu-runner.service DESTINATION /usr/lib/systemd/system/)
endif (SUPPORT_SYSTEMD)
install(FILES tcmu-runner.8
    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man8)

=== debian/changelog ===
tcmu (1.4.0-1) unstable; urgency=medium

  * First release (Closes: #933343)

 -- Sebastien Delafond <seb@debian.org>  Mon, 29 Jul 2019 16:01:03 +0200

=== debian/control ===
Source: tcmu
Section: admin
Priority: optional
Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
Uploaders: Sebastien Delafond <seb@debian.org>
Build-Depends: debhelper (>= 12), cmake, kmod, libkmod-dev, libglib2.0-dev, libnl-genl-3-dev, pkg-config, zlib1g-dev, librbd-dev, librados-dev
Standards-Version: 4.3.0
Homepage: https://github.com/open-iscsi/tcmu-runner
Vcs-Browser: https://salsa.debian.org/freexian-team/tcmu-runner
Vcs-Git: https://salsa.debian.org/freexian-team/tcmu-runner.git

Package: libtcmu2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library that handles the userspace side of the LIO TCM-User backstore
 LIO is the SCSI target in the Linux kernel. It is entirely kernel
 code, and allows exported SCSI logical units (LUNs) to be backed by
 regular files or block devices. But, if one want to get fancier with
 the capabilities of the device one is emulating, the kernel is not
 necessarily the right place. While there are userspace libraries for
 compression, encryption, and clustered storage solutions like Ceph or
 Gluster, these are not accessible from the kernel.
 .
 The TCMU userspace-passthrough backstore allows a userspace process
 to handle requests to a LUN. But since the kernel-user interface that
 TCMU provides must be fast and flexible, it is complex enough that
 one would like to avoid each userspace handler having to write boilerplate
 code.
 .
 tcmu-runner handles the messy details of the TCMU interface -- UIO,
 netlink, pthreads, and DBus -- and exports a more friendly C plugin
 module API. Modules using this API are called "TCMU
 handlers". Handler authors can write code just to handle the SCSI
 commands as desired, and can also link with whatever userspace
 libraries they like.
 .
 This is the library package

Package: tcmu-runner
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Daemon that handles the userspace side of the LIO TCM-User backstore
 LIO is the SCSI target in the Linux kernel. It is entirely kernel
 code, and allows exported SCSI logical units (LUNs) to be backed by
 regular files or block devices. But, if one want to get fancier with
 the capabilities of the device one is emulating, the kernel is not
 necessarily the right place. While there are userspace libraries for
 compression, encryption, and clustered storage solutions like Ceph or
 Gluster, these are not accessible from the kernel.
 .
 The TCMU userspace-passthrough backstore allows a userspace process
 to handle requests to a LUN. But since the kernel-user interface that
 TCMU provides must be fast and flexible, it is complex enough that
 one would like to avoid each userspace handler having to write boilerplate
 code.
 .
 tcmu-runner handles the messy details of the TCMU interface -- UIO,
 netlink, pthreads, and DBus -- and exports a more friendly C plugin
 module API. Modules using this API are called "TCMU
 handlers". Handler authors can write code just to handle the SCSI
 commands as desired, and can also link with whatever userspace
 libraries they like.
 .
 This is the daemon package

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export CMAKE_OPTIONS := \
  -Dwith-glfs=false \
  -DSUPPORT_SYSTEMD=ON \
  -DCMAKE_INSTALL_PREFIX=/usr

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTIONS)

override_dh_auto_install:
	dh_auto_install $@
	find .
	mkdir -p debian/tmp/lib/systemd/system
	mv debian/tmp/usr/lib/systemd/system/tcmu-runner.service debian/tmp/lib/systemd/system/tcmu-runner.service
	rm -r debian/tmp/usr/lib/systemd

override_dh_install:
	dh_install
	cd debian/libtcmu2 ; find . -type f -exec rm -fr ../tcmu-runner/{} \;

## tcmu 1.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required (VERSION 2.8 FATAL_ERROR)
 project (tcmu-runner C)
-set(VERSION 1.4.0)
+set(VERSION 1.5.2)
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wall -Wdeclaration-after-statement -std=c99")
 
 include(GNUInstallDirs)
@@ -11,6 +11,9 @@
 option(with-glfs "build Gluster glfs handler" true)
 option(with-qcow "build qcow handler" true)
 option(with-rbd "build Ceph rbd handler" true)
+option(with-zbc "build zbc handler" true)
+option(with-fbo "build fbo handler" true)
+option(with-tcmalloc "link against tcmalloc" true)
 
 find_library(LIBNL_LIB nl-3)
 find_library(LIBNL_GENL_LIB nl-genl-3)
@@ -32,6 +35,11 @@
 
 find_library(PTHREAD pthread)
 find_library(DL dl)
+
+if (with-tcmalloc)
+  find_library(TCMALLOC_LIB tcmalloc)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-builtin-malloc -fno-builtin-calloc -fno-builtin-realloc -fno-builtin-free")
+endif(with-tcmalloc)
 
 # Stuff for building the shared library
 add_library(tcmu
@@ -48,6 +56,7 @@
   )
 set_target_properties(tcmu
   PROPERTIES
+  VERSION 2.2
   SOVERSION "2"
   )
 target_include_directories(tcmu
@@ -59,8 +68,9 @@
   ${LIBNL_LIB}
   ${LIBNL_GENL_LIB}
   ${GLIB_LIBRARIES}
-  )
-install(TARGETS tcmu LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} NAMELINK_SKIP)
+  ${TCMALLOC_LIB}
+  )
+install(TARGETS tcmu LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
 
 # Stuff for building the static library
 add_library(tcmu_static
@@ -81,6 +91,7 @@
   )
 target_link_libraries(tcmu_static
   ${GLIB_LIBRARIES}
+  ${TCMALLOC_LIB}
   )
 
 # Stuff for building the main binary
@@ -90,6 +101,7 @@
   tcmur_device.c
   target.c
   alua.c
+  scsi.c
   main.c
   tcmuhandler-generated.c
   )
@@ -105,12 +117,14 @@
   ${PTHREAD}
   ${DL}
   ${KMOD_LIBRARIES}
+  ${TCMALLOC_LIB}
   -Wl,--no-export-dynamic
   -Wl,--dynamic-list=${CMAKE_SOURCE_DIR}/main-syms.txt
   )
 install(TARGETS tcmu-runner RUNTIME DESTINATION bin)
 
 add_executable(tcmu-synthesizer
+  scsi.c
   tcmu-synthesizer.c
   )
 target_link_libraries(tcmu-synthesizer tcmu)
@@ -121,6 +135,7 @@
   )
 target_link_libraries(tcmu-synthesizer
   ${GLIB_LIBRARIES}
+  ${TCMALLOC_LIB}
   )
 
 install(TARGETS RUNTIME DESTINATION bin)
@@ -154,39 +169,48 @@
   PUBLIC ${PROJECT_SOURCE_DIR}/ccan
   )
 
-# Stuff for building the file optical handler
-add_library(handler_file_optical
-  SHARED
-  file_optical.c
-  )
-set_target_properties(handler_file_optical
-  PROPERTIES
-  PREFIX ""
-  )
-target_include_directories(handler_file_optical
-  PUBLIC ${PROJECT_SOURCE_DIR}/ccan
-  )
-target_link_libraries(handler_file_optical ${PTHREAD})
-
-# Stuff for building the file zbc handler
-add_library(handler_file_zbc
-  SHARED
-  file_zbc.c
-  )
-set_target_properties(handler_file_zbc
-  PROPERTIES
-  PREFIX ""
-  )
-target_include_directories(handler_file_zbc
-  PUBLIC ${PROJECT_SOURCE_DIR}/ccan
-  )
-install(TARGETS handler_file_zbc DESTINATION ${CMAKE_INSTALL_LIBDIR}/tcmu-runner)
+if (with-fbo)
+	# Stuff for building the file optical handler
+	add_library(handler_file_optical
+  	SHARED
+	scsi.c
+  	file_optical.c
+  	)
+	set_target_properties(handler_file_optical
+  	PROPERTIES
+  	PREFIX ""
+  	)
+	target_include_directories(handler_file_optical
+  	PUBLIC ${PROJECT_SOURCE_DIR}/ccan
+  	)
+	target_link_libraries(handler_file_optical ${PTHREAD} ${TCMALLOC_LIB})
+	install(TARGETS handler_file_optical DESTINATION ${CMAKE_INSTALL_LIBDIR}/tcmu-runner)
+endif (with-fbo)
 
 # The minimal library consumer
 add_executable(consumer
+  scsi.c
   consumer.c
   )
 target_link_libraries(consumer tcmu)
+
+if (with-zbc)
+	# Stuff for building the file zbc handler
+	add_library(handler_file_zbc
+	  SHARED
+	  scsi.c
+	  file_zbc.c
+	  )
+	set_target_properties(handler_file_zbc
+	  PROPERTIES
+	  PREFIX ""
+	  )
+	target_include_directories(handler_file_zbc
+	  PUBLIC ${PROJECT_SOURCE_DIR}/ccan
+	  )
+	target_link_libraries(handler_file_zbc ${TCMALLOC_LIB})
+	install(TARGETS handler_file_zbc DESTINATION ${CMAKE_INSTALL_LIBDIR}/tcmu-runner)
+endif (with-zbc)
 
 if (with-rbd)
 	find_library(LIBRBD rbd)
@@ -205,12 +229,20 @@
 	  )
 	target_link_libraries(handler_rbd
 	  ${LIBRBD}
+	  ${TCMALLOC_LIB}
 	  )
 	install(TARGETS handler_rbd DESTINATION ${CMAKE_INSTALL_LIBDIR}/tcmu-runner)
 endif (with-rbd)
 
 if (with-glfs)
 	find_library(GFAPI gfapi)
+
+    set(GFAPI_VERSION760 0)
+
+    pkg_check_modules(GFAPI760 glusterfs-api>=7.6 QUIET)
+	if (GFAPI760_FOUND)
+		set(GFAPI_VERSION760 1)
+	endif (GFAPI760_FOUND)
 
 	# Stuff for building the glfs handler
 	add_library(handler_glfs
@@ -226,6 +258,7 @@
 	  )
 	target_link_libraries(handler_glfs
 	  ${GFAPI}
+	  ${TCMALLOC_LIB}
 	  )
 	install(TARGETS handler_glfs DESTINATION ${CMAKE_INSTALL_LIBDIR}/tcmu-runner)
 endif (with-glfs)
@@ -255,6 +288,7 @@
 	endif (HAVE_LINUX_FALLOC)
 	target_link_libraries(handler_qcow
 	  ${ZLIB_LIBRARIES}
+	  ${TCMALLOC_LIB}
 	  )
 	install(TARGETS handler_qcow DESTINATION ${CMAKE_INSTALL_LIBDIR}/tcmu-runner)
 endif (with-qcow)

=== debian/changelog ===
tcmu (1.5.2-6) unstable; urgency=high

  * Fix CVE-2021-3139 (Closes: #980007)

 -- Sebastien Delafond <seb@debian.org>  Mon, 18 Jan 2021 09:26:23 +0100

tcmu (1.5.2-5) unstable; urgency=medium

  * Re-enable rbd support on mipsel now that ceph can be built again
    (Closes: #949881)

 -- Sebastien Delafond <seb@debian.org>  Mon, 27 Jan 2020 08:20:22 +0100

tcmu (1.5.2-4) unstable; urgency=medium

  * Build without rbd support on mipsel (Closes: #948723)

 -- Sebastien Delafond <seb@debian.org>  Fri, 24 Jan 2020 17:00:41 +0100

tcmu (1.5.2-3) unstable; urgency=medium

  * Team upload.
  * Add patch to fix 32 bit builds with -Werror.
    Thanks to James Page <james.page@ubuntu.com> (Closes: #946460)
  * Add Pre-Depends with substvars so that the appropriate init-system-helpers
    dependency gets added.

 -- Raphaël Hertzog <raphael@freexian.com>  Wed, 11 Dec 2019 11:17:54 +0100

tcmu (1.5.2-2) unstable; urgency=medium

  * Team upload.
  * Disable -Werror to fix FTBFS on 32 bit architectures.

 -- Raphaël Hertzog <raphael@freexian.com>  Mon, 21 Oct 2019 14:39:15 +0200

tcmu (1.5.2-1) unstable; urgency=medium

  * Team upload
  * Move git repository to debian namespace
  * Bump Standards-Version to 4.4.1
  * Switch to debhelper compat level 12
  * New upstream version 1.5.2
  * Ran wrap-and-sort -s
  * Drop our patches, merged upstream.
  * Don't build against tcmalloc
  * Update symbols file for new release
  * Handle file installation in a more usual way

 -- Raphaël Hertzog <raphael@freexian.com>  Mon, 21 Oct 2019 11:54:29 +0200

tcmu (1.4.0-2) unstable; urgency=medium

  [ Mathieu Parent ]
  * Handle libtcmu2.install on non-amd64 arches
  * Fix package-needs-versioned-debhelper-build-depends 12
  * Fix: file-contains-trailing-whitespace debian/changelog (line 6)
  * Fix debian-watch-file-is-missing
  * Fix using-first-person-in-description line N: we
  * Add debian/libtcmu2.symbols
  * Add "Debian pipeline for Developers"
  * Add README.md to tcmu-runner
  * Allow failure of reprotest
  * Add tcmu-runner init.d service

  [ Frédéric Bonnard ]
  * Fix FTBFS on ppc64*/mips64el (Closes: #939265)
  * Fix Vcs-* fields
  * Complete previous fix on ppc64el

 -- Sebastien Delafond <seb@debian.org>  Mon, 23 Sep 2019 09:11:34 +0200

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,26 @@
 Priority: optional
 Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
 Uploaders: Sebastien Delafond <seb@debian.org>
-Build-Depends: debhelper (>= 12), cmake, kmod, libkmod-dev, libglib2.0-dev, libnl-genl-3-dev, pkg-config, zlib1g-dev, librbd-dev, librados-dev
-Standards-Version: 4.3.0
+Build-Depends:
+ cmake,
+ debhelper-compat (= 12),
+ kmod,
+ libglib2.0-dev,
+ libkmod-dev,
+ libnl-genl-3-dev,
+ librados-dev,
+ librbd-dev,
+ pkg-config,
+ zlib1g-dev
+Standards-Version: 4.4.1
 Homepage: https://github.com/open-iscsi/tcmu-runner
-Vcs-Browser: https://salsa.debian.org/freexian-team/tcmu-runner
-Vcs-Git: https://salsa.debian.org/freexian-team/tcmu-runner.git
+Vcs-Browser: https://salsa.debian.org/debian/tcmu
+Vcs-Git: https://salsa.debian.org/debian/tcmu.git
 
 Package: libtcmu2
 Section: libs
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Library that handles the userspace side of the LIO TCM-User backstore
  LIO is the SCSI target in the Linux kernel. It is entirely kernel
  code, and allows exported SCSI logical units (LUNs) to be backed by
@@ -39,7 +49,8 @@
 
 Package: tcmu-runner
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Daemon that handles the userspace side of the LIO TCM-User backstore
  LIO is the SCSI target in the Linux kernel. It is entirely kernel
  code, and allows exported SCSI logical units (LUNs) to be backed by

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export CMAKE_OPTIONS := \
  -Dwith-glfs=false \
  -Dwith-tcmalloc=false \
  -DSUPPORT_SYSTEMD=ON \
  -DCMAKE_INSTALL_PREFIX=/usr

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTIONS)

override_dh_auto_install:
	dh_auto_install
	# Move systemd file to /lib instead of /usr/lib
	mkdir -p debian/tmp/lib/systemd/system
	mv debian/tmp/usr/lib/systemd/system/tcmu-runner.service debian/tmp/lib/systemd/system/tcmu-runner.service
	rm -r debian/tmp/usr/lib/systemd
	# List files available
	find debian/tmp

override_dh_missing:
	dh_missing --fail-missing

## tcmu 1.5.4

=== debian/changelog ===
tcmu (1.5.4-10) unstable; urgency=medium

  * QA upload.
  * Fix building with CMake 4.  (Closes: #1113561)
  * Drop redundant Rules-Requires-Root: no.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 30 Sep 2025 23:56:39 +0200

tcmu (1.5.4-9) unstable; urgency=medium

  * QA upload.
  * Fix building with -Werror=format-security.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 21 Apr 2024 15:28:18 +0200

tcmu (1.5.4-8) unstable; urgency=medium

  * QA upload.
  * Hardcode the list of 32-bit architectures.  (Closes: #1069453)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 21 Apr 2024 12:46:27 +0200

tcmu (1.5.4-7) unstable; urgency=medium

  * QA upload.
  * Restrict librados-dev build-dependency to 64-bit architectures.
    (Closes: #1069453)
  * Add upstream metadata.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 21 Apr 2024 10:20:23 +0200

tcmu (1.5.4-6) unstable; urgency=medium

  * QA upload.
  * Restrict librbd-dev build-dependency to 64-bit architectures.
    (Closes: #1053169)
  * Clean more generated files.  (Closes: #1046607)

 -- Andreas Beckmann <anbe@debian.org>  Thu, 07 Mar 2024 17:46:11 +0100

tcmu (1.5.4-5) unstable; urgency=medium

  * QA upload.
  * Build-Depends: pkgconf instead of transitional pkg-config
  * Let systemd.pc decide place for systemd system units

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 09 Dec 2023 15:29:26 +0100

tcmu (1.5.4-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Ship systemd unit under /lib/systemd/system so that it can get picked
    up by dh_installsystemd. Closes: #1034214

 -- Cyril Brulebois <kibi@debian.org>  Tue, 25 Apr 2023 17:51:40 +0000

tcmu (1.5.4-4) unstable; urgency=medium

  * QA upload.
  * Add fix-use-after-free.patch. Closes: #1013050
  * d/p/series: Remove mention of non-existing patches.

 -- Håvard F. Aasen <havard.f.aasen@pfft.no>  Sat, 23 Jul 2022 23:53:15 +0200

tcmu (1.5.4-3) unstable; urgency=medium

  * QA upload.
  * debian/rules: Pass arguments to cmake to avoid reproducibility issues.
  * debian/control: Set Rules-Requires-Root to "no".
  * debian/control: Update to debhelper-compat 13.
  * debian/control: Update to Standards-Version 4.6.1.

 -- Vagrant Cascadian <vagrant@debian.org>  Sun, 10 Jul 2022 14:54:28 -0700

tcmu (1.5.4-2) unstable; urgency=medium

  * QA upload.
  * fix lintian warning about odd systemd service location
  * Bump standards version

 -- Neil Williams <codehelp@debian.org>  Fri, 24 Sep 2021 14:08:43 +0100

tcmu (1.5.4-1) experimental; urgency=medium

  [ Sébastien Delafond ]
  * New upstream version 1.5.4
  * Rediff patches
  * Bump-up Standards-Version
  * Update d/libtcmu2.symbols

 -- Sebastien Delafond <seb@debian.org>  Mon, 12 Apr 2021 12:10:12 +0200

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,20 @@
 Source: tcmu
 Section: admin
 Priority: optional
-Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
-Uploaders: Sebastien Delafond <seb@debian.org>
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  kmod,
  libglib2.0-dev,
  libkmod-dev,
  libnl-genl-3-dev,
- librados-dev,
- librbd-dev,
- pkg-config,
+ librados-dev [!armel !armhf !any-i386 !hppa !m68k !powerpc !sh4 !x32],
+ librbd-dev [!armel !armhf !any-i386 !hppa !m68k !powerpc !sh4 !x32],
+ pkgconf,
+ systemd-dev,
  zlib1g-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.6.1
 Homepage: https://github.com/open-iscsi/tcmu-runner
 Vcs-Browser: https://salsa.debian.org/debian/tcmu
 Vcs-Git: https://salsa.debian.org/debian/tcmu.git

=== debian/rules ===
#!/usr/bin/make -f
export deb_systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export CMAKE_OPTIONS := \
  -Dwith-glfs=false \
  -Dwith-tcmalloc=false \
  -Dwith-rbd=$(if $(wildcard /usr/include/rbd/librbd.h),true,false) \
  -DSUPPORT_SYSTEMD=ON \
  -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
  -DCMAKE_INSTALL_PREFIX=/usr

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTIONS)

override_dh_auto_install:
	dh_auto_install
	# List files available
	find debian/tmp

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%tcmu-runner-$1.tar.gz%" \
     https://github.com/open-iscsi/tcmu-runner/tags \
     (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
